<html>

<b>Product of Array Except for multiplying the Self </b>
<pre>
Given an array nums of n integers 
return an array output such that output[i] is equal to the product of all the elements of nums except nums[i].
Solve without division.

Example:

Input:  [1,2,3,4]
Output: [24,12,8,6]


</pre>
</html>

<pre>

public int[] productExceptSelf(int[] nums) {
   
}


productExceptSelf([1,2,3,4]) => [24,12,8,6]
productExceptSelf([5,2,3,4]) => [24,0,0,0]

</pre>
<b>  Get the maximum profit </b>
<pre>

	Say you have an array for which the kth element is the price of a given bitcoin on day k.

Design an algorithm to find the maximum profit. 

Example 1:

Input: [700,100,500,300,600,400]
Output: 700
Explanation: Buy on day 2 (price = 100) and sell on day 3 (price = 500), profit = 500-100 = 400.
             Then buy on day 4 (price = 300) and sell on day 5 (price = 600), profit = 600-300 = 300.
Example 2:

Input: [101,200,350,479,599]
Output: 498
Explanation: Buy on day 1 (price = 101) and sell on day 5 (price = 599), profit = 599-101 = 498.
             Note that you cannot buy on day 1, buy on day 2 and sell them later, as you are
             engaging multiple transactions at the same time. You must sell before buying again.
Example 3:

Input: [700,600,490,301,100]
Output: 0
Explanation: In this case, no transaction is done, i.e. max profit = 0.
</pre>

<pre>
maxProfit([700,100,500,300,600,400]) = 700  
maxProfit([101,200,350,479,599]) = 498
maxProfit([700,600,490,301,100]) = 0

	
</pre>

<pre>
1. How does the ArrayList indexOf() method
determine equality between the object passed
to the method and an element in the array

2.Compare and contrast an array to an ArrayList
by describing the differences between the two
for:
 a) accessing an element.
 b) adding an element.
 c) deleting an element.
 d) assigning a new value to an element.
 e) determining the size of the collection.

</pre>

<pre>
	<b> Codebat format </b>

Return the sum of all the numbers at odd positions in the array list.


sumOddIndexes([1, 2, 3, 4]) → 6
sumOddIndexes([8, 16, 10]) → 16
sumOddIndexes([5, 0, -10]) → 0

public int sumEvenIndexes(List<Integer> numsList) 
  
}

sumOddIndexes([1, 2, 3, 4]) → 4	
sumOddIndexes([8, 16, 10]) → 16		
sumOddIndexes([5, 0, -10]) → 0
sumOddIndexes([2, 1, 4, 8, 200]) → 9
sumOddIndexes([]) → 0

</pre>


<pre>
Given an integer array nums, find the contiguous subarray (containing at least one number) which has the largest sum and return its sum.

Example:

Input: [-2,1,-3,4,-1,2,1,-5,4],
Output: 6
Explanation: [4,-1,2,1] has the largest sum = 6.


 input
[-2,1,-3,4,-1,2,1,5,4]
Output
15

 input
[-2,1,3,4,1,2,1,5,4]
Output
21


Initialize:
    max = 0
    max_ending = 0

Loop for each element of the array
  (a) max_ending = max_ending + a[i]
  (b) if(max_ending < 0)
            max_ending = 0
  (c) if(max_current < max_ending)
            max_current = max_ending
return max_current

</pre>

